byte clockPin = 12;
byte latchPin = 10;
byte dataPin = 11;
byte inputPin = 13;

byte digits[11] = {
  0B11111100, // 0
  0B01100000, // 1
  0B11011010, // 2
  0B11110010, // 3
  0B01100110, // 4
  0B10110110, // 5
  0B10111110, // 6
  0B11100000, // 7
  0B11111110, // 8
  0B11110110, // 9
  0B00000000, // space
};

unsigned long counter = 0;
boolean cntEnabled = false;

byte LEDisplay[8] = {10, 10, 10, 10, 10, 10, 10, 0}; // Initially we display zero with leading spaces

void setup() {
  byte i;

  pinMode(latchPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
  pinMode(inputPin, INPUT);

  TCNT1 = 0;
  TCCR1A = 0;
  TCCR1B = (1<<WGM12);
  TCCR1B |= (1<<CS11); // Prescaler is 8!
  OCR1A = 39999; // 50 interrupt per second.
  TIMSK1 = (1<<OCIE1A);
  for (i = 2; i <= 9; i++) {
    digitalWrite(i, LOW);
  }

  sei();

  while(digitalRead(inputPin)) {
  }
  cntEnabled = true;
}

void loop() {
}

void refreshDisplay() {
  byte i;
  
  for (i = 0; i <=7; i++) {
    digitalWrite(latchPin, LOW);
    shiftOut(dataPin, clockPin, MSBFIRST, digits[LEDisplay[i]]);
    digitalWrite(latchPin, HIGH);
    digitalWrite(i + 2, HIGH);
    delayMicroseconds(666); // Change it for brightness adjust!
    digitalWrite(i + 2, LOW);
  } 
}

void setDisplay() {
  unsigned long cnt;
  int pos = 7;
  
  cnt = counter;
  while (cnt > 0 && pos >= 0) {
    LEDisplay[pos] = cnt % 10;
    cnt = cnt /10;
    pos--;
  }
}

ISR (TIMER1_COMPA_vect) {
  if (digitalRead(inputPin)) {
    cntEnabled = false;
  }
  
  if (cntEnabled) {
    counter++;
  }

  setDisplay(); 
  refreshDisplay();
}
